/'* \file
 * \brief initializes dial, gauge, colorbrowser, colorbar controls.
 *
 * See Copyright Notice in "iup.bi"
 '/
 
#ifndef __IUPCONTROLS_BI
#define __IUPCONTROLS_BI

#inclib "iupcontrols"
#inclib "iupcd"
#inclib "cd"
#inclib "freetype6"

Extern "C"

Declare Function IupControlsOpen () As Integer
Declare Sub IupControlsClose ()   /' for backward compatibility only, does nothing since IUP 3 '/

Declare Sub IupOldValOpen ()
Declare Sub IupOldTabsOpen ()

Declare Function IupColorbar () As Ihandle Ptr
Declare Function IupCells () As Ihandle Ptr
Declare Function IupColorBrowser () As Ihandle Ptr
Declare Function IupGauge () As Ihandle Ptr
Declare Function IupDial (ByVal type_ As ZString Ptr) As Ihandle Ptr
Declare Function IupMatrix (ByVal action As ZString Ptr) As Ihandle Ptr
Declare Function IupTree () As Ihandle Ptr

/' IupTree utilities '/
Declare Function IupTreeSetUserId (ByVal ih As Ihandle Ptr, ByVal id As Integer, ByVal userid As Any Ptr) As Integer
Declare Function IupTreeGetUserId (ByVal ih As Ihandle Ptr, ByVal id As Integer) As Any Ptr
Declare Function IupTreeGetId (ByVal ih As Ihandle Ptr, ByVal userid As Any Ptr) As Integer
Declare Sub IupTreeSetAttribute   (ByVal ih As Ihandle Ptr, ByVal a As Const ZString Ptr, _
																	ByVal id As Integer, ByVal v As ZString Ptr)
Declare Sub IupTreeStoreAttribute (ByVal ih As Ihandle Ptr, ByVal a As Const ZString Ptr, _
																	ByVal id As Integer, ByVal v As ZString Ptr)
Declare Function IupTreeGetAttribute   (ByVal ih As Ihandle Ptr, ByVal a As Const ZString Ptr, ByVal id As Integer) As ZString Ptr
Declare Function IupTreeGetInt         (ByVal ih As Ihandle Ptr, ByVal a As Const ZString Ptr, ByVal id As Integer) As Integer
Declare Function IupTreeGetFloat       (ByVal ih As Ihandle Ptr, ByVal a As Const ZString Ptr, ByVal id As Integer) As Single
Declare Sub IupTreeSetfAttribute  (ByVal ih As Ihandle Ptr, ByVal a As Const ZString Ptr, _
																	ByVal id As Integer, ByVal f As ZString Ptr, ...)

/' IupMatrix utilities '/
Declare Sub IupMatSetAttribute   (ByVal ih As Ihandle Ptr, ByVal a As Const ZString Ptr, _
																	ByVal l As Integer, ByVal c As Integer, _
																	ByVal v As ZString Ptr)
Declare Sub IupMatStoreAttribute (ByVal ih As Ihandle Ptr, ByVal a As Const ZString Ptr, _
																	ByVal l As Integer, ByVal c As Integer, _
																	ByVal v As ZString Ptr)
Declare Function IupMatGetAttribute   (ByVal ih As Ihandle Ptr, ByVal a As Const ZString Ptr, _
																			ByVal l As Integer, ByVal c As Integer) As ZString Ptr
Declare Function IupMatGetInt         (ByVal ih As Ihandle Ptr, ByVal a As Const ZString Ptr, _
																			ByVal l As Integer, ByVal c As Integer) As Integer
Declare Function IupMatGetFloat       (ByVal ih As Ihandle Ptr, ByVal a As Const ZString Ptr, _
																			ByVal l As Integer, ByVal c As Integer) As Single
Declare Sub IupMatSetfAttribute  (ByVal ih As Ihandle Ptr, ByVal a As Const ZString Ptr, _
																	ByVal l As Integer, ByVal c As Integer, ByVal f As ZString Ptr, ...)

End Extern

/' Used by IupColorbar '/
#define IUP_PRIMARY -1
#define IUP_SECONDARY -2

#endif