/'IupVbox Example in C 

Creates a dialog with buttons placed one above the other, 
showing the organization possibilities of the elements inside a vbox. 
The "ALIGNMENT" attribute is explored in all its possibilities 
to obtain the effects. Several attributes are tested. 

'/


#macro w(a)
Print "All is well";a:sleep()
#endmacro

#define NULL Cast(Any Ptr,0)

/' ANSI C libraries include '/
#include "crt/stdlib.bi"
#include "crt/stdio.bi"

/' IUP libraries include '/
#include "iup3/iup.bi"

/' Main program '/
Sub main()
	
		
  /' IUP identifiers '/
  Dim As Ihandle Ptr dlg
  Dim As Ihandle Ptr frm_1, frm_2, frm_3
  Dim As Ihandle Ptr btn_11, btn_12, btn_13
  Dim As Ihandle Ptr btn_21, btn_22, btn_23
  Dim As Ihandle Ptr btn_31, btn_32, btn_33
  Dim As Ihandle Ptr vbox_main, vbox_1, vbox_2, vbox_3

  /' Initializes IUP '/
  IupOpen(NULL,NULL)

  /' Program begin '/

	'btn_11 = IupButton ("","")
  'btn_12 = IupButton ("","")
  'btn_13 = IupButton ("","")
  
	/' Creates frame 1 '/
  vbox_1 = IupVbox _
     ( _
       IupFill(), _
			 IupButton ("&One", ""), _
       IupButton ("&Two", ""), _
       IupButton ("Th&ree", ""), _
			 IupFill(), _
       NULL _
     )
		 
	frm_1 = IupFrame(vbox_1)
	
  

  /' Sets title of frame 1 '/
  
	IupSetAttribute (frm_1, "TITLE", "ALIGNMENT = ALEFT, GAP = 10")
	IupSetAttribute(frm_1,"SIZE","480x100")
	IupSetAttribute(frm_1,"EXPAND","YES")
	
	
  /' Sets attributes of vbox 1 '/
  IupSetAttribute (vbox_1, "ALIGNMENT","ALEFT")
	IupSetAttribute(vbox_1,"GAP","10")	
	IupSetAttribute(vbox_1,"EXPAND","YES")
	IupSetAttribute(vbox_1,"HOMOGENEOUS","YES")		
	IupSetAttribute(vbox_1,"EXPANDCHILDREN","YES")		
	
	vbox_2 = IupVbox _
      ( _
        IupFill(), _
				IupButton ("&Four", ""), _
        IupButton ("F&ive", ""), _
        IupButton ("Si&x", ""), _
				IupFill(), _
        NULL _
      )
  /' Creates frame 2 '/
  frm_2 = IupFrame(vbox_2)
  

  /' Sets title of frame 1 '/
  
	IupSetAttribute (frm_2, "TITLE", "ALIGNMENT = ACENTER, MARGIN = 15")
	IupSetAttribute(frm_2,"SIZE","480x100")
	IupSetAttribute(frm_2,"EXPAND","YES")
	

	
  /' Sets attributes of vbox 2 '/
  IupSetAttribute (vbox_2, "ALIGNMENT","ACENTER")
	IupSetAttribute (vbox_2, "MARGIN","15")	
	IupSetAttribute(vbox_2,"EXPAND","YES")
	IupSetAttribute(vbox_2,"HOMOGENEOUS","YES")	
	IupSetAttribute(vbox_2,"EXPANDCHILDREN","YES")		
	
	
	vbox_3 = IupVbox _
      ( _
        IupFill(), _
				IupButton ("Se&ven", ""), _
        IupButton ("Eig&ht", ""), _
        IupButton ("Ni&ne", ""), _
				IupFill(), _
        NULL _
      )
  /' Creates frame 3 '/
  frm_3 = IupFrame(vbox_3)
  

  /' Sets title of frame 3 '/
  
	IupSetAttribute (frm_3, "TITLE", "ALIGNMENT = ARIGHT, SIZE = 20")
	IupSetAttribute(frm_3,"SIZE","480x100")
	IupSetAttribute(frm_3,"EXPAND","YES")
	
	
	/' Sets attributes of vbox 3 '/
  IupSetAttribute (vbox_3, "ALIGNMENT","ARIGHT")
	IupSetAttribute(vbox_3,"EXPAND","YES")
	IupSetAttribute(vbox_3,"HOMOGENEOUS","YES")
	IupSetAttribute(vbox_3,"EXPANDCHILDREN","YES")
	
	
  /' Creates dialog with three frames inside a vbo_ '/
  vbox_main = IupVbox(frm_1,frm_2,frm_3,NULL)
	IupSetAttribute (vbox_main, "ALIGNMENT","ARIGHT")	
	IupSetAttribute(vbox_main,"EXPAND","YES")
	IupSetAttribute(vbox_main,"EXPANDCHILDREN","YES")
	IupSetAttribute(vbox_main,"HOMOGENEOUS","YES")		
	dlg = IupDialog _
  ( _
    vbox_main _
  ) 

  /' Sets title and size of the dialog '/  
	IupSetAttribute (dlg, "TITLE","IupVbox Example")
	'IupSetAttribute (dlg, "SIZE","480x320")

  /' Shows dialog in the center of the screen '/
  IupShowXY (dlg, IUP_CENTER, IUP_CENTER)

  /' Initializes IUP main loop '/
  IupMainLoop ()

  /' Finishes IUP '/
  IupClose ()    
  

End Sub

main